<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.7.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <title>List Users</title>
    <script>
        "use strict";
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */


        const gREQUEST_STATUS_OK = 200;
        const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;

        /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        $(document).ready(function () {
            onPageLoading();
            // Xử lý sự kiện onClick lên #table-users, => ủy quyền cho các phần tử con có class là .btn-sua
            $("#table-users").on("click", ".btn-sua", function(){
                onBtnSuaClick (this);
            });

            // Xử lý sự kiện onClick lên #table-users, => ủy quyền cho các phần tử con có class là .btn-xoa
            $("#table-users").on("click", ".btn-xoa", function(){
                onBtnXoaClick (this);
            });
        });

        function onPageLoading() {
            getAllUsers();
        }

        function onBtnSuaClick(paramElement){
            var vId = $(paramElement).data("id");
            console.log ("Nút sửa có data-id là: " + vId);
        }

        function onBtnXoaClick(paramElement){
            var vId = $(paramElement).data("id");
            console.log ("Nút xóa có data-id là: " + vId);
        }
        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
        function getAllUsers() {
            //base url
            const vBASE_URL = "http://203.171.20.210:8080/crud-api/users/";
            // create a request
            var vXmlHttObj = new XMLHttpRequest();
            vXmlHttObj.open("GET", vBASE_URL, true);
            vXmlHttObj.send();
            vXmlHttObj.onreadystatechange = function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    var vUrsersObject = JSON.parse(vXmlHttObj.responseText);
                    loadDataIntoTable(vUrsersObject);
                }
            }

        }

        function loadDataIntoTable(paramUsersObject) {
            console.log(paramUsersObject);
            var vTable = $("#table-users");
            for (var bIndex = 0; bIndex < paramUsersObject.length; bIndex++) {
                var vTr = $("<tr>").appendTo(vTable);
                $("<td>", { html: paramUsersObject[bIndex].id }).appendTo(vTr);
                $("<td>", { html: paramUsersObject[bIndex].firstname }).appendTo(vTr);
                $("<td>", { html: paramUsersObject[bIndex].lastname }).appendTo(vTr);
                $("<td>", { html: paramUsersObject[bIndex].country }).appendTo(vTr);
                $("<td>", { html: paramUsersObject[bIndex].subject }).appendTo(vTr);
                $("<td>", { html: paramUsersObject[bIndex].customerType }).appendTo(vTr);
                $("<td>", { html: paramUsersObject[bIndex].registerStatus }).appendTo(vTr);
                var vActionTd = $("<td>").appendTo(vTr);
                $("<button>", { 
                    class: "btn btn-primary mr-2 btn-sua", 
                    html: "Sửa", 
                })
                .data("id",paramUsersObject[bIndex].id).
                appendTo(vActionTd);

                $("<button>", { 
                    class: "btn btn-danger btn-xoa", 
                    html: "Xóa" 
                })
                .data("id",paramUsersObject[bIndex].id)
                .appendTo(vActionTd);
            }
        }
    </script>
</head>

<body>
    <div class="container">
        <h2 class="text-center my-4">Danh sách người dùng đăng ký</h2>
        <table id="table-users" class="table table-striped table-bordered table-hover">
            <thead>
                <tr>
                    <th scope="col">ID</th>
                    <th scope="col">Firstname</th>
                    <th scope="col">Lastname</th>
                    <th scope="col">Country</th>
                    <th scope="col">Subject</th>
                    <th scope="col">Customer Type</th>
                    <th scope="col">Register Status</th>
                    <th scope="col">Action</th>
                </tr>
            </thead>
            <tbody>

            </tbody>
        </table>
    </div>
</body>

</html>